theory Petersons imports OpSem_ProofRules 
begin

consts flag1 :: L
       flag2 :: L
       turn  :: L

record P =
r1::V
r2::V
r3::V
r4::V
after1:: bool
after2:: bool
\<sigma> :: surrey_state


definition "pg s   \<equiv> wfs s \<and> flag1\<noteq>flag2 \<and> flag1\<noteq>turn \<and> turn \<noteq> flag2 \<and>
init_val s flag1 0 \<and> init_val s flag2 0 \<and> init_val s turn 0 \<and> 
(cvd[turn, 0] s \<or> cvd[turn, 1] s \<or> cvd[turn, 2] s)"

lemmas petersons [simp] = pg_def  
lemmas defs_del [simp del] =  Rd_def Let_def Wr_def Upd_def st_rd_def val_rd_def

lemma Peterson:
"
\<parallel>- 

\<lbrace>pg \<acute>\<sigma> \<and>  \<not> \<acute>after1 \<and>  \<not> \<acute>after2 
       \<and> [flag1 =\<^sub>1 0 ]\<acute>\<sigma> \<and> [flag2 =\<^sub>2 0]\<acute>\<sigma>  \<and> [turn =\<^sub>1 0]\<acute>\<sigma> \<and> [turn =\<^sub>2 0]\<acute>\<sigma> \<rbrace>

COBEGIN

\<lbrace>pg \<acute>\<sigma> \<and> \<not> \<acute>after1 \<and> [flag1 =\<^sub>1 0]\<acute>\<sigma> \<and> (cvd[turn, 0]\<acute>\<sigma> \<or> cvd[turn, 1]\<acute>\<sigma>)
       \<and> (\<acute>after2 \<longrightarrow> cvd[turn, 1]\<acute>\<sigma> \<and> [turn = 1]\<lparr>flag2 =\<^sub>1 1\<rparr>\<acute>\<sigma>)
       \<and>  \<not> [turn \<approx>\<^sub>2 2]\<acute>\<sigma> \<rbrace>

  <flag1 :=\<^sub>1 1 \<acute>\<sigma>>;;

\<lbrace>pg \<acute>\<sigma> \<and> \<not> \<acute>after1 \<and> [flag1 =\<^sub>1 1]\<acute>\<sigma>
       \<and> (\<acute>after2 \<longrightarrow> cvd[turn, 1]\<acute>\<sigma> \<and> [turn = 1]\<lparr>flag2 =\<^sub>1 1\<rparr>\<acute>\<sigma>) 
       \<and>  \<not> [turn \<approx>\<^sub>2 2]\<acute>\<sigma> \<rbrace>

  \<langle><SWAP[turn, 2]\<^sub>1 \<acute>\<sigma>>,, \<acute>after1 := True\<rangle> ;;

DO
\<lbrace>pg \<acute>\<sigma> \<and> \<acute>after1
       \<and> (\<acute>after2 \<and> ([flag2 \<approx>\<^sub>1 0]\<acute>\<sigma> \<or> [turn \<approx>\<^sub>1 1]\<acute>\<sigma>) \<longrightarrow>  [turn =\<^sub>2 1]\<acute>\<sigma>) \<rbrace>

  <\<acute>r1 \<leftarrow>\<^sup>A\<^sub>1 flag2 \<acute>\<sigma>>;;

\<lbrace>pg \<acute>\<sigma> \<and>\<acute>after1 
       \<and> (\<acute>after2 \<and> (\<acute>r1 = 0 \<or> [turn \<approx>\<^sub>1 1]\<acute>\<sigma> \<or> [flag2 \<approx>\<^sub>1 0]\<acute>\<sigma>) \<longrightarrow>  [turn =\<^sub>2 1]\<acute>\<sigma>)\<rbrace>

  <\<acute>r2 \<leftarrow>\<^sub>1 turn \<acute>\<sigma>>
UNTIL (\<acute>r1 = 0 \<or> \<acute>r2 = 1)
INV \<lbrace>pg \<acute>\<sigma> \<and> \<acute>after1   \<and>
     (\<acute>after2 \<and> (\<acute>r1 = 0 \<or> \<acute>r2 = 1 \<or> [turn \<approx>\<^sub>1 1]\<acute>\<sigma> \<or> [flag2 \<approx>\<^sub>1 0]\<acute>\<sigma>) \<longrightarrow>  [turn =\<^sub>2 1]\<acute>\<sigma>) \<rbrace>
OD ;;

  \<lbrace>pg \<acute>\<sigma> \<and> \<acute>after1 \<and> (\<acute>after2 \<longrightarrow> [turn =\<^sub>2 1] (\<acute>\<sigma>))\<rbrace>

  \<langle><flag1 :=\<^sup>R\<^sub>1 0 \<acute>\<sigma>>,, \<acute>after1 := False\<rangle>

\<lbrace>True\<rbrace>

\<parallel>

\<lbrace>pg \<acute>\<sigma> \<and> \<not> \<acute>after2 \<and> [flag2 =\<^sub>2 0]\<acute>\<sigma> \<and> (cvd[turn, 0] (\<acute>\<sigma>) \<or> cvd[turn, 2]\<acute>\<sigma>)
       \<and> (\<acute>after1 \<longrightarrow> cvd[turn, 2]\<acute>\<sigma> \<and> [turn = 2]\<lparr>flag1 =\<^sub>2 1\<rparr>\<acute>\<sigma>)
       \<and> \<not> [turn \<approx>\<^sub>1 1]\<acute>\<sigma>\<rbrace>

<flag2 :=\<^sub>2 1 \<acute>\<sigma>>;;

\<lbrace>pg \<acute>\<sigma> \<and> \<not> \<acute>after2 \<and> [flag2 =\<^sub>2 1]\<acute>\<sigma> 
       \<and> (\<acute>after1  \<longrightarrow> cvd[turn, 2]\<acute>\<sigma> \<and> [turn = 2]\<lparr>flag1 =\<^sub>2 1\<rparr>\<acute>\<sigma>) 
       \<and> \<not> [turn \<approx>\<^sub>1 1]\<acute>\<sigma>\<rbrace>

  \<langle><SWAP[turn, 1]\<^sub>2 \<acute>\<sigma>>,, \<acute>after2 := True\<rangle> ;;

DO
  \<lbrace>pg \<acute>\<sigma> \<and> \<acute>after2 
         \<and> (\<acute>after1 \<and> ([flag1 \<approx>\<^sub>2 0]\<acute>\<sigma> \<or> [turn \<approx>\<^sub>2 2]\<acute>\<sigma>) \<longrightarrow>  [turn =\<^sub>1 2]\<acute>\<sigma>)\<rbrace>

  <\<acute>r3 \<leftarrow>\<^sup>A\<^sub>2 flag1 \<acute>\<sigma>>;;

  \<lbrace>pg \<acute>\<sigma> \<and>\<acute>after2 
         \<and> (\<acute>after1 \<and> (\<acute>r3 = 0 \<or> [turn \<approx>\<^sub>2 2]\<acute>\<sigma> \<or> [flag1 \<approx>\<^sub>2 0]\<acute>\<sigma>) \<longrightarrow>  [turn =\<^sub>1 2]\<acute>\<sigma>) \<rbrace>

  <\<acute>r4 \<leftarrow>\<^sub>2 turn \<acute>\<sigma>>

UNTIL (\<acute>r3 = 0 \<or> \<acute>r4 = 2)
INV \<lbrace>pg \<acute>\<sigma> \<and> \<acute>after2 
           \<and> (\<acute>after1 \<and> (\<acute>r3 = 0 \<or> \<acute>r4 = 2 \<or> [turn \<approx>\<^sub>2 2]\<acute>\<sigma> \<or> [flag1 \<approx>\<^sub>2 0]\<acute>\<sigma>) \<longrightarrow>  [turn =\<^sub>1 2]\<acute>\<sigma>)\<rbrace>
OD ;;

\<lbrace>pg \<acute>\<sigma> \<and>\<acute>after2
                \<and> (\<acute>after1 \<longrightarrow> [turn =\<^sub>1 2]\<acute>\<sigma>)\<rbrace>

 \<langle><flag2 :=\<^sup>R\<^sub>2 0 \<acute>\<sigma>>,, \<acute>after2 := False\<rangle>

\<lbrace>True\<rbrace>

COEND
\<lbrace> True\<rbrace> "
apply (oghoare;(simp add: Collect_conj_eq[symmetric] Collect_imp_eq[symmetric] Collect_disj_eq[symmetric] Collect_mono_iff )?; clarify?, simp_all?)
using OpSemExtProof.covered_contradiction apply metis
apply auto[1]
using OpSem_ProofRules.covered_update_pres_ext OpSem_ProofRules.ext_cvd_up_dobs OpSem_ProofRules.ext_cvd_update_d_obs OpSem_ProofRules.update_pres_wfs d_obs_p_obs_agree n_not_Suc_n 
apply metis
using not_pobs_contradiction OpSem_ProofRules.c_obs_read_d_obs OpSem_ProofRules.ext_cvd_rd_pres OpSem_ProofRules.ext_d_obs_rd_pres OpSem_ProofRules.p_obs_contradiction OpSem_ProofRules.read_pres_wfs d_obs_implies_p_obs not_p_obs_implies_c_obs
apply (metis+)[4]
using OpSem_ProofRules.covered_wr_diif_var_pres OpSem_ProofRules.covered_update_pres_ext OpSem_ProofRules.ext_cvd_up_dobs OpSem_ProofRules.ext_cvd_update_d_obs OpSem_ProofRules.update_pres_wfs d_obs_p_obs_agree n_not_Suc_n 
apply (metis+)[2]
using not_pobs_contradiction OpSem_ProofRules.c_obs_read_d_obs OpSem_ProofRules.ext_cvd_rd_pres OpSem_ProofRules.ext_d_obs_rd_pres OpSem_ProofRules.p_obs_contradiction OpSem_ProofRules.read_pres_wfs d_obs_implies_p_obs not_p_obs_implies_c_obs
apply (metis+)[4]
  using OpSem_ProofRules.covered_wr_diif_var_pres OpSem_ProofRules.covered_update_pres_ext OpSem_ProofRules.ext_cvd_up_dobs OpSem_ProofRules.update_pres_wfs d_obs_p_obs_agree n_not_Suc_n numeral_2_eq_2 
        OpSem_ProofRules.ext_cvd_rd_pres OpSem_ProofRules.ext_d_obs_rd_pres OpSem_ProofRules.p_obs_contradiction
  by metis+

end

